#!/usr/bin/perl
# $Id: address.cgi,v 1.10 2004/05/26 19:26:15 jzawacki Exp $

# ****** USE THIS STUFF *******
use CGI;	 my $amail=CGI->new(); # THIS IS THE MAIN CGI OBJECT
use DB_File;
use email_common;
require 'setup.pl';
require "lang/$::Language_Default";

# ****** SET THESE VARIABLES *******
my ($dir_URL, $db_path, $img_URL) = Set_location;

my $info_color = "green";
my $problem_color = "red";
my $remove_gif = "$img_URL/remove.gif";
my $edit_gif = "$img_URL/edit.gif";
my $addto_gif = "$img_URL/AddTo.gif";

# ****** VARIABLES *********
my @addresses;
my $address_mess;
my $re_nickname;    # stores entries whose nickname is taken
my @address_info;
my @group_info;
my %address_sort;

my $email_ID = $amail->param('email_ID');
my $SID = $amail->param('SID');

# Before we can invoke this script, we have to check that the SID is correct and up to date.
 Check_session($email_ID, $SID);

my $nickn=$amail->param('nickn');
my $lastn=$amail->param('lastn');
my $firstn=$amail->param('firstn');
my $email=$amail->param('email');
my $GOTO=$amail->param('GOTO');
if ($amail->param('GOTO2') eq 'makeGroup') {$GOTO = 'makeGroup'}    # we use GOTO2 only for this, it's a workaround
my $Add_Edit = $amail->param('Add_Edit');   # this can be "Add Entry" or "Edit Entry", another workaround
$GOTO = $Add_Edit if $Add_Edit;           # if this exists, we want to go there.
my $index=$amail->param('index');
my $groupname=$amail->param('groupname');
$groupname =~ s/'/&#39;/g;
my $sort_by = ($GOTO eq 'Add') ? 4 : $amail->param('sortby') || 2;   # sort by defaults to 2 (last name), unless we're
                                                            # adding from a message, we use 4 (email address)

#my ($nickn2,$lastn2,$firstn2,$email2);

# We know we need all the entries, so we get it all first, and leave the file open
# increment $highest_index for the next entry index , @contacts is the individuals and @groups is the groups
open (ADDRESS,"+<$db_path/$email_ID/address_book") || die "$lang{CouldNotOpen} $db_path/$email_ID/address_book. $!";
chop (my $highest_index = <ADDRESS>);    # this is the highest index we've used so far, remove the \n
@addresses = <ADDRESS>;
my (@contacts,@groups);
while (($_ = shift @addresses) and ($_ ne "\n")) {      # make sure there's something, stop at \n
    push @contacts,$_;
}
while (($_ = shift @addresses)) {         # the rest is groups
    push @groups,$_;
}

my %next_screen = ("$lang{RemoveContacts}"          => \&Remove_from_group,  # remove contacts from an existing group
		   "$lang{AddContacts}"             => \&Add_to_group,       # add something to an existing group from edit group
		   "addGroup"                 => \&Add_group,          # make new group, names sent in
		   "editGroup"                => \&Edit_group,         # change entries or group name
		   "Remove"                   => \&Remove_entry,       # remove a single entry
		   "$lang{EditContact}"             => \&Edit_entry,         # edit contact from address book
		   "$lang{AddContact}"              => \&Add_entry,          # add individual entry from main form
		   "$lang{AddAddresses}"            => \&Add_addresses,      # submitted the addresses from an email
		   "Add"                      => \&Add_from_email,     # the addresses from an email are handed over
		   "gRemove"                  => \&Remove_group,       # remove the whole group
		   "Finished"                 => \&Finish_group,       # change group name id desired
		   "addTo"                    => \&Add_to_group2,      # adds to group from address book page
		   "makeGroup"                => \&Make_group,         # makes a group from an email
		  );
if ($next_screen{$GOTO}) {
    $next_screen{$GOTO}->();	# call the correct subroutine
}
else {
    &Show_book;
}

sub Remove_entry {
    for (my $i=0; $i < @contacts; $i++) {
	@address_info = split /,/, $contacts[$i];
	if ($address_info[4] == $index) {
	    splice @contacts, $i, 1;        # take out the address book entry
	    foreach my $group (@groups) {          # we have to check each group to see if this contact is in there
		@group_info = split /\|/, $group;
		chop $group_info[2];      # remove the \n
		my @group_contacts = split /,/, $group_info[2];    # these are the contacts in the group
		for (my $j; $j < @group_contacts; $j++) {
		    if ($group_contacts[$j] =~ /^\@(\d+)/) {    # this one is a reference to an index number
			if ($1 == $index) {           # this is the one we are removing
			    splice @group_contacts, $j, 1;   # take out the contact from the group
			    $group_info[1]--;                # there's one less contact now
			    $group_info[2] = join ',', @group_contacts;     # reform the group contacts
			    $group = (join '|', @group_info) . "\n";    # reform the group
			    last;   # stop checking the contacts in the group
			}
		    }
		}
	    }   # go through the rest of the groups
	    $address_mess = "$lang{RemovedContact}";
	    seek ADDRESS, 0, 0;
	    print ADDRESS $highest_index,"\n",@contacts,"\n",@groups;
	    truncate ADDRESS, tell ADDRESS;
	    last;
	}
    }
    &Show_book;
}

sub Edit_entry {
    unless ($index) { # we don't know who to edit
	&Show_book;
	return;
    }
    my @contacts_backup = @contacts;
    for (my $i=0; $i < @contacts; $i++) {         # take out the line we are editing
	@address_info = split /,/, $contacts[$i]; # otherwise, when we check for repeated email or nickname later ...
	if ($address_info[4] == $index) {
	    splice @contacts, $i, 1;
	    last;
	}
    }
    &Add_entry2(@contacts_backup);
}

sub Add_entry {
    $index = ++$highest_index;
    &Add_entry2(@contacts);
}

sub Add_entry2 {

    my @contacts_backup = @_;   # we revert to this if we don't change anything
    unless ($lastn or $firstn or $nickn or $email) {   # we better have something
	@contacts = @contacts_backup if @contacts_backup;    # if we are editing, we took the line out earlier.
	$address_mess .= "<font color='$problem_color'>$lang{AddressNoInfo}</font>";
    }
    else {
	my $new_entry = &Verify_entry($nickn,$lastn,$firstn,$email);
	if ($new_entry == 1) {   # nickname exists already -- this might cause a run time warning, but it's OK
	    @contacts = @contacts_backup;       # there's a problem, dont change a thing
	    $address_mess .= "<font color='$problem_color'>$lang{AddressNickTaken}</font>";
	}
	elsif ($new_entry == 2) {   # email already exists
	    @contacts = @contacts_backup;
	    $address_mess .= "<font color='$problem_color'>$lang{AddressEmailUsed}</font><br>";
	}
	else {        # no problems with it, lets add it.
	    $new_entry .= "," . $index . "\n";
	    push @contacts, $new_entry;  # put the new one on the array
	    seek ADDRESS, 0, 0;
	    print ADDRESS $highest_index,"\n",@contacts,"\n",@groups;     # and print it to the address_book file
	    truncate ADDRESS, tell ADDRESS;
	}
    }
    &Show_book;
}

sub Add_addresses {                    # We have submitted the Add_from_email_form

    my @email_entries = $amail->param('addem');           # These are the email addresses to be added
    unless (@email_entries) {
	$address_mess = "<font color='$problem_color'>$lang{AddressNotSelected}</font>";
    }
    else {
	my $add_count = 0;
	$re_nickname = "";      #  these are the entries with illegal nicknames, we need to redo them
	foreach (@email_entries) {
	    my ($addr_num, $email) = split /,/, $_, 2;    # we send it as the index number and the email address
	    $nickn = $amail->param('n_name' . $addr_num);
	    $lastn = $amail->param('l_name' . $addr_num);     # this info was sent with index number
	    $firstn = $amail->param('f_name' . $addr_num);
	    my $new_entry = Verify_entry ($nickn,$lastn,$firstn,$email);
	    if ($new_entry == 1) {   # nickname already taken
	        $re_nickname .= "$firstn $lastn $email,";
		next;
	    }
	    if ($new_entry == 2) {   # email taken, but this shouldn't be, so we're skipping this
		next;
	    }
	    $highest_index++;
	    $new_entry .= "," . $highest_index . "\n";
	    push @contacts, $new_entry;       # add to array
	    $add_count++;
	}
	seek ADDRESS, 0, 0;
	print ADDRESS $highest_index,"\n",@contacts,"\n",@groups;
	my $plural = ($add_count == 1) ? "" : "es";
	$address_mess = "$add_count $lang{AddressAdded}";
    }
    if ($re_nickname) {   # we had some problems, and we are going back.
	$address_mess .= "<br><font color='$problem_color'>$lang{AddressNickTaken}</font>";
	&Add_from_email_form ($re_nickname);      # send these back to the user, we added the others
    }
    else {    # we had no problems, so go back to address book
	&Show_book;
    }
}

sub Sort_contacts {       # the info isn't changing, so we're making a hash of all contacts, the keys are the sortby field
    close ADDRESS || die "$lang{CouldNotClose} $db_path/$email_ID/address_book. $!";
    foreach (@contacts) {
	chop;           # take off carriage returns
	my @address_info = split /,/;  #  nickn, lastn, firstn, email, index

	my $sort_key = lc $address_info[$sort_by - 1];         # this is the field we are sorting by
	unless ($sort_key) {      # this field is blank for this entry
	    $sort_key = "zzzzz";    # make it the last alphabetically if it does not have a value
	}
	while (defined $address_sort{$sort_key}) {   # if this field already exists (i.e. first name john (smith or jones))
	    $sort_key .= "z";     # add something to the end to make it unique
	}
	$address_sort{$sort_key} = \@address_info;        # make a hash of arrays
    }
}

#if ($GOTO eq 'Add' or $re_nickname) {      # this adds addresses from an email or loops through if nickname taken
sub Add_from_email {
    my $names = $amail->param('names');
    $names =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;
    &Add_from_email_form ($names);
}

sub Show_book {
    &Sort_contacts;
    my $javascript = "
this.window.focus()
function addTo(groupname) {
aForm=document.addressForm
aForm.GOTO.value='addTo'
aForm.groupname.value=groupname
aForm.submit()
}
function gRemove(groupname) {
conf=window.prompt('$lang{About2Delete} \"'+groupname+'\". $lang{AreYouSure}','Yes, go on!')
if (conf != 'Yes, go on!') { return }
aForm=document.addressForm
aForm.GOTO.value='gRemove'
aForm.groupname.value=groupname
aForm.submit()
}
function Group() {
aForm=document.addressForm
nf=window.prompt('$lang{NameGroup}','');
if(nf==null || nf=='null' || nf=='') {
return;
}
aForm.groupname.value=nf
aForm.GOTO.value='addGroup'
aForm.submit()
}
function SetChecked() {
cForm=document.composeForm
aForm=document.addressForm
cForm.to.value=''
cForm.cc.value=''
cForm.bcc.value=''
var i=0
len=aForm.elements.length
for( i=0 ; i<len ; i++) {
if (aForm.elements[i].name=='to' && aForm.elements[i].checked) {
cForm.to.value+=','+aForm.elements[i].value
}
if (aForm.elements[i].name=='cc' && aForm.elements[i].checked) {
cForm.cc.value+=','+aForm.elements[i].value
}
if (aForm.elements[i].name=='bcc' && aForm.elements[i].checked) {
cForm.bcc.value+=','+aForm.elements[i].value
}}}

function Compose() {
cForm=document.composeForm
SetChecked()
var to=cForm.to.value
var cc=cForm.cc.value
var bcc=cForm.bcc.value
oForm=this.opener.document.compForm
if (oForm != null) {
if (oForm.to.value == '') {
to = to.substring(1, to.length)
}
oForm.to.value += to
if (oForm.cc.value == '') {
cc = cc.substring(1, cc.length)
}
oForm.cc.value += cc
if (oForm.bcc.value == '') {
bcc = bcc.substring(1, bcc.length)
}
oForm.bcc.value += bcc
window.close()
return
}
cForm.to.value = to.substring(1, to.length)
cForm.cc.value = cc.substring(1, cc.length)
cForm.bcc.value = bcc.substring(1, bcc.length)
var comp=window.open('', 'compose', 'width=650,height=450,scrollbars=yes')
cForm.target='compose'
cForm.submit()
aForm.reset()
}
function Remove(index) {
conf=window.prompt('$lang{About2Delete} $lang{Contact}. $lang{AreYouSure}','Yes, go on!')
if (conf != 'Yes, go on!') { return }
aForm=document.addressForm
aForm.GOTO.value='Remove'
aForm.index.value=index
aForm.submit()
}
function gEdit(groupname){
aForm=document.addressForm
aForm.groupname.value=groupname
aForm.GOTO.value='editGroup'
aForm.submit()
}
function Edit(index,nickn,lastn,firstn,email) {
aForm=document.addressForm
aForm.nickn.value=nickn
aForm.lastn.value=lastn
aForm.firstn.value=firstn
aForm.email.value=email
aForm.Add_Edit.value='$lang{EditContact}'
aForm.index.value=index
window.location.href='#enter'
}
function Reset_form() {
aForm=document.addressForm
aForm.reset()
aForm.index.value=''
aForm.Add_Edit.value='$lang{AddContact}'
}
function Sortby(num) {
aForm=document.addressForm
aForm.sortby.value=num
aForm.submit()
}";


    print $amail->header;
    print $amail->start_html(-title=>"$lang{AddressBook4} $email_ID",
			     -bgcolor=>"$background_color",
			     -script=>$javascript,
			    );
    print $headerad if $headerad_on_all_message;
    Caption("$lang{AddressBook4} <b>$email_ID</b>");

    print "<font color='$info_color'>$address_mess</font>" if $address_mess;
    print <<EOP;
<FORM NAME='composeForm' action='compose.cgi'>
<INPUT TYPE='hidden' NAME='email_ID' VALUE='$email_ID'>
<INPUT TYPE='hidden' NAME='SID' VALUE='$SID'>
<INPUT TYPE='hidden' NAME='to' VALUE=''>
<INPUT TYPE='hidden' NAME='cc' VALUE=''>
<INPUT TYPE='hidden' NAME='bcc' VALUE=''>
</FORM>
<FORM NAME='addressForm' action='address.cgi'>
<INPUT TYPE='hidden' NAME='email_ID' VALUE='$email_ID'>
<INPUT TYPE='hidden' NAME='SID' VALUE='$SID'>
<INPUT TYPE='hidden' NAME='GOTO' VALUE=''>
<INPUT TYPE='hidden' NAME='index' VALUE=''>
<INPUT TYPE='hidden' NAME='sortby' VALUE='$sort_by'>
<INPUT TYPE='hidden' NAME='groupname' VALUE=''>
<center>
<p valign='bottom'>
<table width=100%><tr valign=bottom>
<td><INPUT TYPE='button' value='$lang{ComposeMail}' onClick='javascript:Compose()'> <INPUT TYPE='button' value='$lang{MakeGroup}' onClick='javascript:Group()'></td>
<td width=5%>&nbsp;</td>
<td><font size='-1'>$lang{AddressInfo1} $lang{MakeGroup}
<br><a href='#enter'>$lang{AddContact}</a> -- <a href='#groups'>$lang{SeeGroups}</a></font></td>
</tr></table>
<table bgcolor='#DDAADD' cellspacing=2 cellpadding=2 border=0>
<tr valign=bottom>
<td bgcolor='CCCC99'><font size=-1>$lang{To}:</font></td>
<td bgcolor='CCCC99'><font size=-1>$lang{CC}:</font></td>
<td bgcolor='CCCC99'><font size=-1>$lang{BCC}:</font></td>
<td align='center'><a href='javascript:Sortby(1)'>$lang{NickName}</a></td>
EOP

    if ($sort_by == 3) {	# if we sort by first name then its first name first
	print "<td align='center'><a href='javascript:Sortby(3)'>$lang{FirstName}</a> | <a href='javascript:Sortby(2)'>$lang{LastName}</a></td>";
    } else {			# any other sort, we print last name first
	print "<td align='center'><a href='javascript:Sortby(2)'>$lang{LastName}</a> / <a href='javascript:Sortby(3)'>$lang{FirstName}</a></td>";
    }
    print <<EOP;
<td align='center'><a href='javascript:Sortby(4)'>$lang{Email}</a></td>
<td align='center'>$lang{Actions}</td>
</tr>
EOP
    my $count = 0;
    unless (%address_sort) {
	print "<tr bgcolor='DDDDDD'><td colspan=7 align=center><font size=+1>You have no entries in your address book.</font></td></tr>";
    }
    else {
	foreach (sort keys %address_sort) {
	    @address_info = @{$address_sort{$_}};
	    my $fullname;
	    my $space = ($address_info[1] && $address_info[2]) ? " " : "";
	    if ($sort_by == 3) {    # if we sort by first name, then first name first
		$fullname = "$address_info[2]$space$address_info[1]";
	    } else {		# any other sort is last name first
		$fullname = ($address_info[1] && $address_info[2]) ? # if we only have one, no comma or space
		  "$address_info[1], $address_info[2]" :
		    "$address_info[1]$address_info[2]";
	    }
	    my $mailname;
	    if ($address_info[1] || $address_info[2]) {
		$mailname = "&quot;$address_info[2]$space$address_info[1]&quot;&lt;$address_info[3]&gt;";
	    }
	    else {
		$mailname = "$address_info[3]";
	    }
	    print "<tr bgcolor='#",(($count % 2) ? "EEEEEE":"DDDDDD"),"'><td><INPUT TYPE='checkbox' NAME='to' VALUE='$mailname'></td><td><INPUT TYPE='checkbox' NAME='cc' VALUE='$mailname'></td><td><INPUT TYPE='checkbox' NAME='bcc' VALUE='$mailname'></td><td>",$address_info[0] || "&nbsp;","</td><td>",$fullname || "&nbsp;","</td><td>",$address_info[3] || "&nbsp;","</td>",
	      "<td><a href='javascript:Remove(\"$address_info[4]\")'><img src='$remove_gif' border=0 alt='$lang{RemoveContact}'></a>",
		"<a href='javascript:Edit(\"$address_info[4]\",\"$address_info[0]\",\"$address_info[1]\",\"$address_info[2]\",\"$address_info[3]\")'><img src='$edit_gif' border=0 alt='$lang{EditContact}'></a></td>",
		  #	"<a href=\"javascript:Edit('$address_info[0]','$address_info[1]','$address_info[2]','$address_info[3]','$address_info[4]','$address_info[5]')\"><img src='$edit_gif' border=0 alt='$lang{EditContact}'></a></td>",
		  "</tr>\n";
	    $count++;
	}
    }
    print <<EOP;
</table>
<table width=100%><tr valign=bottom>
<td valign=top><INPUT TYPE='button' value='$lang{ComposeMail}' onClick='javascript:Compose()'> <INPUT TYPE='button' value='$lang{MakeGroup}' onClick='javascript:Group()'></td>
<td width=5%>&nbsp;</td>
<td><font size='-1'><img src='$edit_gif'> - $lang{EditContact}<img src='$remove_gif'> - $lang{RemoveContact}<br>$lang{AddressInfo2}<br><a href='#enter'>$lang{Add}</a></font></td>
</tr></table>
<a name="groups">
<p><font size=-1>$lang{AddressInfo3}</font>
<table bgcolor='#DDAADD' cellspacing=2 cellpadding=2 border=0>
<tr valign=bottom>
<td bgcolor='CCCC99'><font size=-1>$lang{To}:</font></td>
<td bgcolor='CCCC99'><font size=-1>$lang{CC}:</font></td>
<td bgcolor='CCCC99'><font size=-1>$lang{BCC}:</font></td>
<td align='center'>$lang{GroupName}</a></td><td>$lang{Contact}</td><td>$lang{Actions}</td>
</tr>
EOP
    unless (@groups) {
	print "<tr bgcolor='DDDDDD'><td colspan=6 align=center><font size=+1>$lang{NoGroups}</font></td></tr>";
    }
    else {
	$count = 0;
	foreach (sort @groups) {
	    @group_info = split /\|/;
	    print "<tr bgcolor='#",(($count % 2) ? "EEEEEE":"DDDDDD"),"'>",
	      "<td><INPUT TYPE='checkbox' NAME='to' VALUE='$group_info[0]'></td>",
		"<td><INPUT TYPE='checkbox' NAME='cc' VALUE='$group_info[0]'></td>",
		  "<td><INPUT TYPE='checkbox' NAME='bcc' VALUE='$group_info[0]'></td>",
		    "<td>$group_info[0]</td>",
		      "<td align=center>$group_info[1]</td>",
			"<td><a href='javascript:gRemove(\"$group_info[0]\")'><img src='$remove_gif' border=0 alt='$lang{RemoveGroup} $group_info[0]'></a>",
			  "<a href='javascript:gEdit(\"$group_info[0]\")'><img src='$edit_gif' border=0 alt='$lang{EditGroup} $group_info[0]'></a>",
			    "<a href='javascript:addTo(\"$group_info[0]\")'><img src='$addto_gif' border=0 alt='$lang{AddAddresses} $group_info[0]'></a></td>",
			      "</tr>";
	}
    }
#<img src='$remove_gif'> - $lang{RemoveGroup}<img src='$edit_gif'> - $lang{EditGroup}<img src='$addto_gif> - $lang{AddAddresses}</td></tr></table>
    print <<EOP;
</table>
<table><tr><td align=center><img src='$remove_gif'> - $lang{RemoveGroup}<img src='$edit_gif'> - $lang{EditGroup}<br><img src='$addto_gif'> - $lang{AddAddresses}</td></tr></table>
<hr><center>
<a name="enter"></a>
<font size=+2><input type='submit' name='Add_Edit' value='$lang{AddContact}'></font><br>
<p><font size=-1>$lang{AddressInfo4}</font>
<table>
<tr><td align=right>$lang{NickName}: </td><td><INPUT TYPE='text' NAME='nickn' size=12></td></tr>
<tr><td align=right>$lang{LastName}: </td><td><INPUT TYPE='text' NAME='lastn' size=12></td></tr>
<tr><td align=right>$lang{FirstName}: </td><td><INPUT TYPE='text' NAME='firstn' size=12></td></tr>
<tr><td align=right>$lang{Email}: </td><td><INPUT TYPE='text' NAME='email' size=22></td></tr>
<tr><td colspan=2 align=center><INPUT TYPE='button' VALUE='$lang{ResetForm}' onClick='javascript:Reset_form()'></td></tr>
</table>
</form>
</body></html>
EOP
}

sub Verify_entry {     # makes sure that no repeats of email or nicknames
    my @new_info = @_;          # this is the entry to be entered, same order as address_info
    foreach (@new_info) {
		s/[,"]//g;   # take out all commas and ", they shouldn't be in there anyway
    }
    foreach (@contacts) {
	@address_info = split /,/;
	if ($new_info[0] and $new_info[0] eq $address_info[0]) {     # if there's a nickname, and it exists
	    return 1;     # nickname already exists
	}
	if ($new_info[3] and $new_info[3] eq $address_info[3]) {     # if there's an email, and it exists
	    return 2;      # email already exists
	}
    }
    foreach (@groups) {
	@group_info = split /\|/;
	if ($new_info[0] and $new_info[0] eq $group_info[0]) {     # if there's a nickname, and it exists
	    return 1;     # nickname already exists
	}
    }
    $new_info[0] =~ s/\@/_/g;  # there can't be any @ in the nickname or it will look like an email
    my $new_entry = (join ',', @new_info);
    $new_entry =~ s/'/&#39;/g;   # store all apostraphes as the html code for it
    return $new_entry;
}

sub Add_from_email_form {
    &Sort_contacts;       # makes hash of all entries with key being the sort field, sort by 1st name
    my $names = shift;
    my @names;
    push(@names, $+) while $names =~ m{([^,\"]*(?:".*?")?[^,]*),?}gx;  # take out csv values, looks for quotes
    my ($f_name, $l_name, %already_in_book, %new_names, @group_contacts);
  NAME_LOOP:    foreach my $name (@names) {
	unless ($name =~ s/<?([\w.-]+@[\w.-]+)>?//) {      # take out the email address
	    next;  # if no email address, move on
	}
	my $email = $1;   # email address taken from reg exp above
	my $email_lc = lc $email;  # lower case
        foreach (keys %address_sort) {  # the keys are the email address, all lowercase
	    if ($email_lc eq $_) {       # if we already have the email in the book
		$already_in_book{$email_lc} = $address_sort{$email_lc};
		push @group_contacts, ('@' . ${$address_sort{$email_lc}}[4]);      # this is the list for making a group
		next NAME_LOOP;       # go on the the next name
	    }
	}
	$name =~ s/^[\s()<>"']*(.*?)[\s()<>"']*$/$1/;        # Take out leading and trailing space and enclosers
        push @group_contacts, "\"$name\"<$email>";      # this is the list for making the group
	if ($name =~ /(.*)\s*,\s*(.*)/) {   # if it's comma, then Last, First
	    $f_name = $2;
	    $l_name = $1;
	}
	elsif ($name =~ /(.*)\s+(.*)/) {      # if we have a space in there, then it should be <First Name> <Last Name>
	    $f_name = $1;
	    $l_name = $2;
	}
	else {          # if it's just one name then put it as last name
	    $l_name = $name;
	    $f_name="";
	}
	$new_names{$email} = [$l_name, $f_name];    # a hash of arrays
    }
    my $group_list = join ',', @group_contacts;       # this is the group list we'll send along in the form

my $javascript = "
this.window.focus()
function makeGroup() {
aForm=document.addForm
nf=window.prompt('$lang{NameGroup}','');
if(nf==null || nf=='null' || nf=='') {
return;
}
aForm.groupname.value=nf
aForm.GOTO2.value='makeGroup'
aForm.submit()
}";
    print $amail->header;
    print $amail->start_html(-title=>"$lang{AddingAddresses4} $email_ID",
			     -bgcolor=>"$background_color",
			     -script=>$javascript,
			    );

    Caption("$lang{AddingAddresses4} <b>$email_ID</b>");
    print "<font color='$info_color'>$address_mess</font>" if $address_mess;

    my $count = 0;
#    $names =~ s/'/&#39;/g;
#<INPUT TYPE='hidden' NAME='names' VALUE='$names'>
    print <<EOP;
<FORM NAME='addForm' ACTION='address.cgi'>
<INPUT TYPE='hidden' NAME='email_ID' VALUE='$email_ID'>
<INPUT TYPE='hidden' NAME='SID' VALUE='$SID'>
<INPUT TYPE='hidden' NAME='group_list' VALUE='$group_list'>
<INPUT TYPE='hidden' NAME='groupname' VALUE=''>
<INPUT TYPE='hidden' NAME='GOTO2' VALUE=''>
EOP
    if (%new_names) {      # if we have any new names, do this
	print <<EOP;
<font color='$info_color' size=+1>$lang{NotInBook}</font><br>
<INPUT TYPE='submit' VALUE='$lang{AddAddresses}' NAME='GOTO'><br>
<font size='-1'>$lang{AddressInfo5}</font>
<table bgcolor='#DDAADD' cellspacing=2 cellpadding=2 border=0 width='100%'>
<tr>
<td>&nbsp;</td>
<td align='center'$lang{Email}</td>
<td align='center'>$lang{NickName}</td>
<td align='center'>$lang{LastName}</td>
<td align='center'>$lang{FirstName}</td>
</tr>
EOP
	foreach my $email (sort keys %new_names) {
	    $count++;
	    print "<tr bgcolor='#",(($count % 2) ? "EEEEEE":"DDDDDD"),"'>",
	      "<td><INPUT TYPE='checkbox' VALUE='$count,$email' NAME='addem'></td>",
		                                         # identify the selection by number and email, separated by ,
		"<td>$email</td>",
		  "<td><INPUT TYPE='text' NAME='n_name$count' size=9></td>",   # each field has a number at the end
		    "<td><INPUT TYPE='text' NAME='l_name$count' VALUE='$new_names{$email}->[0]' size=12></td>",
		      "<td><INPUT TYPE='text' NAME='f_name$count' VALUE='$new_names{$email}->[1]' size=9></td>",
	                  "</tr>";
	}
	print "</table><font size=-1><INPUT TYPE='submit' VALUE='$lang{AddAddresses}' NAME='GOTO'><br>$lang{AddressInfo5}</font></form><hr>";
    }
    else {
	print "<font color='$info_color'>$lang{AllInBook}</font><br><hr><br>";
    }
    if (%already_in_book) {
	print <<EOP;
<font color='$info_color' size=+1>$lang{SomeInBook}</font>
<table bgcolor='#DDCCCC' cellspacing=2 cellpadding=2 border=0 width='100%'>
<tr>
<td align='center'>$lang{Email}</td>
<td align='center'>$lang{NickName}</td>
<td align='center'>$lang{LastName}</td>
<td align='center'>$lang{FirstName}</td>
</tr>
EOP
	foreach my $email (sort keys %already_in_book) {
	    $count++;
	    print "<tr bgcolor='#",(($count % 2) ? "EEEEEE":"DDDDDD"),"'>",
		"<td>$email</td>",
		  "<td>",$already_in_book{$email}->[0] || "&nbsp;","</td>",
		    "<td>",$already_in_book{$email}->[1] || "&nbsp;","</td>",
		      "<td>",$already_in_book{$email}->[2] || "&nbsp;","</td>";
	}
	print "</table>";
    }

    print "</body></html>";
}

sub Add_group {
    my @to=$amail->param('to');
    my @cc=$amail->param('cc');
    my @bcc=$amail->param('bcc');

    &Make_new_group(@to,@cc,@bcc);
    &Show_book;
}
sub Make_new_group {       # takes an array of emails to add
    my @group_contacts = @_;
    my (%check_hash,$group_list,@group_list,$num_contacts,$contact,$member,%contact);
    $groupname =~ s/[,"|]//g;   # take out all commas and ", they shouldn't be in there anyway
    unless ($groupname) {  # if we have no group name, lets get out of here
	return;
    }
    foreach (@contacts) {
	@address_info = split /,/;
	if ($groupname eq $address_info[0]) {     # if the group name is a nickname we can't use it again
	    $address_mess = "<font color='$problem_color'>$lang{GroupNick}</font>";
	    return;
	}
	chop $address_info[4];
	#set this hash if we have an email to the index number.
	$contact{lc $address_info[3]} = "\@$address_info[4]" if ($address_info[3]);  # an @ at the beginning means index num
    }
    foreach (@groups) {
	@group_info = split /\|/;
	if ($groupname eq $group_info[0]) {     # if the group name is a nickname
	    $address_mess = "<font color='$problem_color'>$lang{GroupNameTaken}</font>"; # nickname already exists
	    return;
	}
    }
#print $amail->header;print @group_contacts,"asdfasd";exit;
    foreach $member (@group_contacts) {
	unless ($check_hash{$member}) {    # this will take out any duplicates in case both to and cc were selected
	    $check_hash{$member} = 1;     # been there, done that
	    if ($member =~ /([\w.-]+@[\w.-]+)/) {  # find the email address,
		$email = lc $1;          # this is the email address of the new group member
		$member = $contact{$email} if $contact{$email};     # replace the person with a index number, if we have it
	    }
	    elsif ($member !~ /^\@\d+/) {   # we have no email and its not an index (they start with @)
		next;
	    }
            push @group_list, $member;      # member is either an email or an index number
	}
    }
#print $amail->header;print @group_list;exit;
    unless (@group_list) {   # make sure we have at least one address
	return;
    }
    $address_mess = "<b>$groupname</b> $lang{GroupAdded}";
    $group_list = join ',', @group_list;
    $num_contacts = @group_list;
    my $new_group = (join '|', ($groupname,$num_contacts,$group_list)) . "\n";
    $new_group =~ s/'/&#39;/g;
    push @groups, $new_group;
    seek ADDRESS, 0, 0;
    print ADDRESS $highest_index,"\n",@contacts,"\n",@groups;
    truncate ADDRESS, tell ADDRESS;
#    &Show_book;
}

sub Edit_group {
    unless ($groupname) {   # we dont know who to edit
	&Show_book;
	return;
    }
    my @group_edit;
    foreach (@groups) {
	chop;  # take off \n at end
	@group_info = split /\|/;
	if ($group_info[0] eq $groupname) {
	    @group_edit = @group_info;
	    last;
	}
    }
    unless (@group_edit) {   # we cant find the group info
	&Show_book;
	return;
    }
    close ADDRESS || die "$lang{CouldNotClose} $db_path/$email_ID/address_book. $!";

    # group_list is the list of names in the group (maybe nicknames, maybe emails)
    my @group_list = split /,/,$group_edit[2];
    
    my %contact_hash;
    foreach (@contacts) {        # make hash of arrays with index number as keys
	my @address_info = split /,/;
	next unless $address_info[3];     # make sure there's an email address, or skip this one
	chop $address_info[4];
	unless ($address_info[1] || $address_info[2]) {
	    $contact_hash{$address_info[4]} = $address_info[3];    # just the email if we have no name
	}
	else {
	    my $space = ($address_info[1] && $address_info[2]) ? "&nbsp;" : "";   # we need a space only if we have both
	    $contact_hash{$address_info[4]} = "$address_info[2]$space$address_info[1]&lt;$address_info[3]&gt;";
	}
    }
    foreach (@group_list) {
	if (/^\@(\d+)/) {       # if we have @ followed by numbers, then its an index
	    $_ = $contact_hash{$1} . "," . $_;    # add the email to the index
	    delete($contact_hash{$1});          # remove this entry from the hash, so we have a list of not ins
	}
	else {
	    s/</&lt;/; s/>/&gt;/;
	    $_ = $_ . "," . $_;
	}
    }
    @group_list = sort @group_list;

    my @not_in_group;
    foreach (keys %contact_hash) {
	push @not_in_group, ($contact_hash{$_} . ',@' . $_);
    }
    @not_in_group = sort @not_in_group;
    print $amail->header;
    print $amail->start_html(-title=>"$lang{EditingGroup4} $email_ID",
			     -bgcolor=>"$background_color",
#			     -script=>$javascript,
			    );
    
    Caption("$lang{EditingGroup4} <b>$email_ID</b>");
    print "<font color='$info_color'>$address_mess</font>" if $address_mess;
    print <<EOP;
<FORM NAME='addressForm' action='address.cgi'>
<INPUT TYPE='hidden' NAME='email_ID' VALUE='$email_ID'>
<INPUT TYPE='hidden' NAME='SID' VALUE='$SID'>
<INPUT TYPE='hidden' NAME='groupname' VALUE='$groupname'>
<table border=0>
<tr><td colspan=2>Group Name: <INPUT TYPE=text NAME='groupname2' VALUE='$groupname' SIZE=12>&nbsp;&nbsp;&nbsp;
<INPUT TYPE=submit NAME='GOTO' VALUE='Finished'>
</td></tr>
EOP
    unless (@group_list) {    # we have no contacts in the group
	print "<tr><td colspan=2><font size=+1 color='red'>$lang{NoContacts}</font></td></tr>";
    }
    else {
	print "<tr><td><SELECT NAME='in_group' SIZE=8 MULTIPLE>";
	foreach (@group_list) {
	    next unless $_;
	    my ($email,$index) = split /,/;
	    print "<OPTION VALUE='$index'>$email";
	}
	print <<EOP;
</SELECT></td><td>$lang{AddressInfo6}<br>
<INPUT TYPE=submit NAME='GOTO' VALUE='$lang{RemoveContacts}'></td></tr>
EOP
    }
    unless (@not_in_group) {
	print "<tr><td colspan=2><font size=+1 color='red'>$lang{AllInGroup}</font></td></tr>";
    }
    else {
	print "<tr><td><SELECT NAME='not_in_group' SIZE=8 MULTIPLE>";
	foreach (@not_in_group) {
	    next unless $_;
	    my ($email,$index) = split /,/;
	    print "<OPTION VALUE='$index'>$email";
	}
	print <<EOP;
</SELECT></td><td>$lang{InBookNotGroup}<br>
<INPUT TYPE=submit NAME='GOTO' VALUE='$lang{AddContacts}'></td></tr>
EOP
    }
    print "</table>";
}
sub Remove_from_group {
    my @remove_these = $amail->param('in_group');
    unless (@remove_these) {   # none to remove
	&Edit_group;
	return;
    }
    my (@group_edit,$ref_group);
    foreach (@groups) {
	@group_info = split /\|/;
	chop $group_info[2];
	if ($group_info[0] eq $groupname) {
	    @group_edit = @group_info;  # this records the information about the group
	    $ref_group = \$_;   # this records the placement of the group in the array groups
	    last;
	}
    }
    unless (@group_edit) {   # we cant find the group info
	&Show_book;
	return;
    }
    my @group_list = split /,/,$group_edit[2];       # these are the contacts in the group
    for (my $i; $i < @group_list; $i++) {
	  foreach (@remove_these) {
	    if ($_ eq $group_list[$i]) {
		splice @group_list, $i, 1;
		$i--;
		last;
	    }
	}
    }
    $group_edit[1] = @group_list;
    $group_edit[2] = join ',', @group_list;
    $$ref_group = (join '|', @group_edit) . "\n";
    seek ADDRESS, 0, 0;
    print ADDRESS $highest_index,"\n",@contacts,"\n",@groups;
    truncate ADDRESS, tell ADDRESS;
    &Edit_group;        # now we go back to editting the group
}

sub Add_to_group {
    my @add_these = $amail->param('not_in_group');
    unless (@add_these) {
	&Edit_group;
	return;
    }
    my (@group_edit,$ref_group);
    foreach (@groups) {
	@group_info = split /\|/;
	chop $group_info[2];
	if ($group_info[0] eq $groupname) {
	    @group_edit = @group_info;  # this records the information about the group
	    $ref_group = \$_;   # this records the placement of the group in the array groups
	    last;
	}
    }
    unless (@group_edit) {   # we cant find the group info
	&Show_book;
	return;
    }
    if ($group_edit[2]) {        # if there was nothing in the group, then the join adds an extra comma
	$group_edit[2] = join ',', $group_edit[2], @add_these;
    }
    else {      # we had no contacts so now we're just the added ones.
	$group_edit[2] = join ',', @add_these;
    }
    $group_edit[1] += @add_these;
    $$ref_group = (join '|', @group_edit) . "\n";
    seek ADDRESS, 0, 0;
    print ADDRESS $highest_index,"\n",@contacts,"\n",@groups;
    truncate ADDRESS, tell ADDRESS;
    &Edit_group;        # now we go back to editting the group
}

sub Remove_group {
    unless ($groupname) {
	&Show_book;
	return;
    }
    for (my $i; $i < @groups; $i++) {
	if ((split /\|/, $groups[$i])[0] eq $groupname) {
	    splice @groups, $i, 1;
	    $address_mess = "<b>$groupname</b> $lang{GroupRemoved}";
	    last;
	}
    }
    seek ADDRESS, 0, 0;
    print ADDRESS $highest_index,"\n",@contacts,"\n",@groups;
    truncate ADDRESS, tell ADDRESS;
    &Show_book;
}

sub Finish_group {    # just check if the name is changed, then back to book
    my $groupname2 = $amail->param('groupname2');
    $groupname2 =~ s/[,"|]//g;   # take out all commas and "'s and |'s, they shouldn't be in there anyway
    $groupname2 =~ s/'/&#39;/g;
    if (!$groupname2 or ($groupname2 eq $groupname)) {   # we're not changing the group name, so just show book
	&Show_book;
	return;
    }
    # from here on, we are trying to change the group name
    foreach (@contacts) {
	@address_info = split /,/;
	if ($groupname2 eq $address_info[0]) {     # if the group name is a nickname
	    $address_mess = "<font color='$problem_color'>$lang{GroupNick}</font>";   # nickname already exists
	    &Edit_group;
	    return;
	}
    }
    my (@group_edit,$ref_group);
    foreach (@groups) {
	@group_info = split /\|/;
	if ($groupname eq $group_info[0]) {     # this is the group we are changing
	    @group_edit = @group_info;
	    $ref_group = \$_;
	}
	elsif ($groupname2 eq $group_info[0]) {     # this means that we matched some other group name
	    $address_mess = "<font color='$problem_color'>$lang{GroupNameTaken}</font>"; # nickname already exists
	    &Edit_group;
	    return;
	}
    }
    unless ($ref_group) {  # we didn't find the group to change
	&Show_book;
	return;
    }
    # everything is OK, let's change the group name and write it
    $group_edit[0] = $groupname2;
    $$ref_group = join '|', @group_edit;
    $address_mess = "<b>$groupname</b> $lang{Changed2} <b>$groupname2</b>.";
    seek ADDRESS, 0, 0;
    print ADDRESS $highest_index,"\n",@contacts,"\n",@groups;
    truncate ADDRESS, tell ADDRESS;
    &Show_book;
}

sub Add_to_group2 {    # this adds to the group from the address book screen, not the edit group page
    my @to=$amail->param('to');
    my @cc=$amail->param('cc');
    my @bcc=$amail->param('bcc');
    my (%check_hash,$group_list,@group_new_list,$contact,$member,%contact,$num_contacts,@group_contacts,$ref_group);
    unless ($groupname and (@to or @cc or @bcc)) {  # we need a groupname and what to add
	&Show_book;
	return;
    }
    foreach (@groups) {
	@group_info = split /\|/;
	if ($group_info[0] eq $groupname) { # this is the group
	    chop $group_info[2];
	    $num_contacts = $group_info[1];
#	    @group_edit = @group_info;  # this records the information about the group
	    @group_contacts = split /,/, $group_info[2];     # this is an array of contacts in the group
	    $ref_group = \$_;   # this records the placement of the group in the array groups
	    last;
	}
    }
    unless (defined $num_contacts) {   # we cant find the group info
	&Show_book;
	return;
    }
    foreach (@contacts) {
	@address_info = split /,/;
	chop $address_info[4];
	#set this hash if we have an email to the index number.
	$contact{lc $address_info[3]} = "\@$address_info[4]" if ($address_info[3]);  # an @ at the beginning means index num
    }
  NEW_MEMBER_LOOP: foreach $member (@to,@cc,@bcc) {
	unless ($check_hash{$member}) {    # this will take out any duplicates in case both to and cc were selected
	    $check_hash{$member} = 1;  # just records that we've seen this one already
	    $member =~ /([\w.-]+@[\w.-]+)/;  # find the email address,
	    $email = lc $1;          # this is the email address of the new group member
	    unless ($email) {     # unless we have an email address, let's move on.
		next;
	    }
	    $member = $contact{$email} if $contact{$email};     # replace the person with a index number, if we have it
	    foreach (@group_contacts) {
		next NEW_MEMBER_LOOP if ($_ eq $member);   # if we already have that contact, don't add it
	    }
            push @group_new_list, $member;      # member is either an email or an index number
	}
    }
    unless (@group_new_list) {   # make sure we have at least one address to add
	&Show_book;
	return;
    }
    my $plural = (@group_new_list == 1) ? "" : "es";
    $address_mess = "Added " . scalar(@group_new_list) . " new address$plural to the group <b>$groupname</b>.";
    $num_contacts += @group_new_list;
#    @group_contacts = join ',', @group_contacts, @group_new_list;
    $$ref_group = (join '|', $groupname, $num_contacts,(join ',', @group_contacts, @group_new_list)) . "\n";
    seek ADDRESS, 0, 0;
    print ADDRESS $highest_index,"\n",@contacts,"\n",@groups;
    truncate ADDRESS, tell ADDRESS;
    &Show_book;
}

sub Make_group {
    my $group_list = $amail->param('group_list');
    my @group_contacts;
    push(@group_contacts, $+) while $group_list =~ m{([^,\"]*(?:".*?")?[^,]*),?}gx;  # take out csv values, looks for quotes
#print $amail->header;print @group_contacts;exit;    
    &Make_new_group(@group_contacts);
    &Show_book;
}
