require 'setup.pl';
package email_common;
use Exporter;
# $Id: email_common.pm,v 1.15 2004/09/28 19:12:44 azawacki Exp $

@ISA = ('Exporter');
@EXPORT = qw/Check_session Caption Parse_header Parse_email_date Make_undo Check_folder_name Put_message Get_head Set_location Server_time is_admin_user Check_quota/;

sub Set_location {   # this sets the file location variable for each script
    return ($::dir_URL, $::db_path, $::img_URL);
}

sub Server_time {    # This returns the time the server is behind eastern time.
    return $::time_off_from_eastern;
}

sub Check_session {
    my ($email_ID, $SID) = @_;
    unless ($email_ID and $SID and -e "$::db_path/$email_ID/sessID") {
	&Go_login(2)
    }

    # The session file exists, let's read it.
    open (SESSION,"<$::db_path/$email_ID/sessID");
    $_ = <SESSION>;
    close SESSION;

    my ($stored_SID,$SID_time,$time_offset) = split / /;
    unless ($stored_SID == $SID) { # The session ID's don't match, maybe abother login
	&Go_login(2)
    }

    unless ((time - $SID_time) < $::time_til_expire) {        # Too late, sorry.
	&Go_login(3)
    }
    # OK, send em on through, all checks out.
    return $time_offset;
}

sub Go_login {     # only used in the check session subroutine
    my $stat=shift;
#    print $email->header;
    print <<EOF;
Content-Type: text/html

<html><head><title>Moving You</title>
<script>top.window.location.href="login.cgi?stat=$stat";</script>
<body bgcolor = "white">
<CENTER><H1><br><br>Back to Login</H1>
<p><a href="login.cgi?stat=$stat" TARGET="_top"> If you are stuck on this page, click on this text to Log back in.</a>
</body></html>
EOF
    exit;
}

sub Caption {  # this is the one line table at the top of each screen
print "<table width='100%' cellpadding=3 cellspacing=1><tr bgcolor=$caption_color><td>",shift,"</td><td width='1%'>&nbsp;&nbsp;&nbsp;&nbsp;</td></tr></table>";
}

sub Parse_header {
    my $header;
    my %header=();
    while ($header = pop @{$_[0]}) { # Go through the header from the end.
        # Look to see if the "for" stuff is found.
	if ($::DEBUGGING) { print $header; print "\r\n"; }
	if ($header =~ /.*\sfor\s.*<([\w.-]+\@[\w\.-]+)>.*/) {
	    $header{"for:"} = $1;
	    if ($::DEBUGGING) { print "Setting 'for:' to $1\r\n"; }
	}
	while ($header =~ s/^\s+// && # If it starts with space (take it out too) and more @header (rfc822 says this one)
	       ($_ = pop @{$_[0]})) { # Not taking out trailing space - I can see using it
	    $header = ($_ . $header);
	}
	my ($header_field, $header_value) = split /:\s*/,$header,2; # split after the colon
	$header{lc $header_field} .= ($header_value); # assign all fields with lowercase field
    }
    if ($::DEBUGGING) { print "\r\n\r\n\r\n"; }
    return %header;
}

# sub Move_messages {        # Takes receiving folder and ref to array of MID's to move
#     my $email_ID = shift;
#     my $folder = shift;
#     my $folder_to = shift;
#     my $ref_MID_list = shift;  # if this is a ref then its a search result
#     my $return_MID = shift;  # tells function to return pointer to next message to show (is the ref to list of message numbers)
#     open(MAILBOX,"<$::db_path/$email_ID/folders") || die "$lang{CouldNotOpen} $::db_path/$email_ID/folders. $!";
#     my ($folder_info,$folder_list,%folder_info,$found);
#     while (($folder_info = <MAILBOX>) and ($folder_info ne "\n")) {   # get folder info
# 	my @folder_info = split /,/, $folder_info;
# 	($found = 1) if ($folder_info[0] eq $folder_to);
# 	$folder_list .= "$folder_info[0],";
# 	chop $folder_info[3];
# 	$folder_info{$folder_info[0]} = \@folder_info;
#     }
#     my @messages = <MAILBOX>;
#     close MAILBOX;

#     my $folder_added = 0;
#     unless ($found) {                    # It's a new folder
# 	if ($_ = Check_folder_name($folder_to)) {   # check if new name OK
# 	    return ($_,$folder_info{$folder},\@messages,$folder_list,$ref_MID_list->[0]);
# 	}
# 	# This looks like a valid folder name
# 	$folder_info{$folder_to} = [$folder_to,0,0,0];   # create new folder entry
# 	$folder_list .= "$folder_to,";
# 	$folder_added = 1;
#     }
#     my (@moved_these);
# #&qqq;
#   MESSAGE_LOOP:    for ($i = 0; $i < @messages; $i++) {
# 	if ($folder eq 'Search Results' || $messages[$i] =~ /^.\|$folder\|/) {
# 	    @this_message = (split /\|/, $messages[$i]);
# 	    foreach $MID (@$ref_MID_list) {
# 		if ($MID == $this_message[5]) { # This message will be moved
# #print "$i -- $MID -- $this_message[5]<br>";
# 		    ${$folder_info{$this_message[1]}}[1]--;         # update the folder info
# 		    ${$folder_info{$folder_to}}[1]++;
# 		    if ($this_message[0] == 0) { # the message is unread
# 			${$folder_info{$this_message[1]}}[2]--;
# 			${$folder_info{$folder_to}}[2]++;
# 		    }
# 		    ${$folder_info{$this_message[1]}}[3] -= $this_message[7];  # size
# 		    ${$folder_info{$folder_to}}[3] += $this_message[7];
# 		    $this_message[1] = $folder_to;
# 		    $messages[$i] = (join '|', @this_message);     # There should be a return at the end of the line already
# 		    push @moved_these, $MID;        # records MID of moved messages and keeps count
# 		    last MESSAGE_LOOP if (@moved_these == @$ref_MID_list);   # if we've moved as many as is in the list, stop
# 		    last;    # otherwise, just stop checking this MID, and go to next one
# 		}
# 	    }
# 	}
#     }
# #exit;
# #&qqq;foreach (@moved_these) {print "$_<br>"};exit;
#     if (@moved_these) {
# 	if ($return_MID) {   # this if from read_mess
# 	    if (ref($return_MID)) {  # it's the reference to a message number, so it's a search
# 		($next_MID, undef) = Seek_search($return_MID, \%folder_info, \@messages, $moved_these[0], 0);
# 		$next_MID = $ref_MID_list->[0] unless $next_MID;
# 	    }
# 	    else {     # not a search
# 		($next_MID, undef) = Seek_message($folder_info{$folder}, \@messages, $ref_MID_list->[0], $moved_these[0], 0);
# 	    }
# 	}
# 	$MAILBOX = Make_undo($email_ID);
# 	foreach (split /,/, $folder_list) {
# 	    print $MAILBOX (join ',', @{$folder_info{$_}}), "\n";
# 	}
# 	print $MAILBOX "\n",@messages;
# 	close $MAILBOX;
#     }
#     return (\@moved_these, $folder_info{$folder}, \@messages, $folder_list, $next_MID, $folder_added);
# }

# sub Remove_from_trash {
#     my $email_ID = shift;
#     my $ref_MID_list = shift;
#     open(MAILBOX,"+<$::db_path/$email_ID/folders") || die "$lang{CouldNotOpen} $::db_path/$email_ID/folders. $!";
#     my (@folders,$folder_info);
#     while (($folder_info = <MAILBOX>) and ($folder_info ne "\n")) {
# 	push @folders,$folder_info;
#     }
#     my @messages = <MAILBOX>;
#     my ($folder_list);
#     foreach (@folders) {
# 	my @folder_info = split /,/;
# 	$folder_list .= "$folder_info[0],";
#     }
#     $ref_Trash_info = [split /,/, $folders[1]];
#     if ($ref_Trash_info->[0] != 'Trash') {        # somethings wrong, trash should be second
# 	close MAILBOX;
# 	return (-1, $ref_Trash_info, \@messages, $folder_list);
#     }
#     my @moved_these;
#   MESSAGE_LOOP:    for ($i=0; $i < @messages; $i++) {
# 	if ($messages[$i] =~ /^.\|Trash\|/) {
# 	    @this_message = (split /\|/, $messages[$i]);
# 	    foreach $MID (@$ref_MID_list) {
# 		if ($MID eq $this_message[5]) { # This message will be moved
# 		    $ref_Trash_info->[1]--;
# 		    $ref_Trash_info->[2]-- unless $this_message[0];
# 		    $ref_Trash_info->[3] -= $this_message[7];
# 		    push @moved_these, $i;
# 		    splice @messages, $i, 1;
# 		    unlink ("$::db_path/$email_ID/$MID");   # and delete
# 		    $i--;            # Decrement becasue we have one less item in the array
# 		    last MESSAGE_LOOP if (@moved_these == @$ref_MID_list);
# 		    last;
# 		}
# 	    }
# 	}
#     }
#     unless (@moved_these) {
# 	close MAILBOX;
# 	return (0,$ref_Trash_info,\@messages,$folder_list);
#     }
#     $folders[1] = (join ',', @$ref_Trash_info) . "\n";
#     seek MAILBOX, 0, 0;
#     print MAILBOX @folders,"\n",@messages;
#     truncate MAILBOX, (tell MAILBOX);
#     close MAILBOX;
#     unlink ("$::db_path/$email_ID/folders.undo");
#     return (scalar(@moved_these),$ref_Trash_info,\@messages,$folder_list);
# }

sub Parse_email_date {
    my @MoY = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
    my %MoY;
    @MoY{@MoY} = (1..12);
    my @Zone = qw/EST EDT CST CDT MST MDT PST PDT/;
    my %Zone;
    @Zone{@Zone} = qw/-0500 -0400 -0600 -0500 -0700 -0600 -0800 -0700/;
    if ($_[0] =~ /\s*(\d\d?)\s*([JFMASOND][a-z][a-z])\s*(\d\d\d\d)\s*(\d\d):(\d\d):?(\d\d)?\s*([\w+-]{1,5})?/)
      {
	  my $zone_offset = 0;
	  return eval {
	      my $t = Time::Local::timegm($6, $5, $4, $1, $MoY{$2}-1, $3-1900);
	      if ($7) {
		  my $time_adjust = $Zone{$7} || $7;
		  # the timezone better be all numbers now ( with a + or - ), or set it to GMT.
		  if ($time_adjust !~ /^[+-]\d{4}$/) {$time_adjust = '+0000'};
		  my ($sign, $hour_off, $min_off) = unpack("a a2 a2",$time_adjust);
		  $zone_offset = ($min_off * 60) + ($hour_off * 3600) * (($sign eq '+') ? 1 : -1);
	      }
	      $t < 0 ? time : ($t - $zone_offset);   # current time is the default time for the message
	  }
      }
    else { return time }
}

sub Show_message_line {
    # Takes string to show, message count, 
    my ($read,$undef,$from,$subject,$date,$MID,$attachment,$mess_size) = split /\|/, $_[0];
    my $message_count = $_[1];
    my $time_offset = $_[2];
    my $marked = $_[3];               # this is the last message we dealyt with, so we mark it with <a name>
    my $paperclip_location = "$::img_URL/paperclip.gif";
    my $checkbox_color = "#90DD90";
    $subject =~ s/%([0-9A-F]{2})/pack("c",hex($1))/ge;
    $from =~ s/%([0-9A-F]{2})/pack("c",hex($1))/ge;
    $subject =~ s/</&lt;/g; $subject =~ s/>/&gt;/g;
    $paperclip = $attachment ? "<img src='$paperclip_location' align=left border=0>" : "";

    my $sent = "";
    if ($from =~ s/(sent.*to )//) { $sent = "sent to " }     # If we sent it, then clean it up
    unless ($from =~ s/(.+)(<.+>)/$sent<a href='javascript:Compose(\"\\\"$1\\\"$2\")'>$1<\/a>/) {
	$from = "$sent<a href='javascript:Compose(\"$from\")'>$from<\/a>";
    }

    if ($read) {print "<tr bgcolor=#",(($message_count % 2) ? "EEEEEE":"DDDDDD"),">"} # alternate the line colors
    else       {print "<tr bgcolor=#",(($message_count % 2) ? "EEEEAA":"DDDDBB"),">"}	 # alternate the line colors
my $MARK;
if ($marked == 1) { $MARK = "<a name='MARK'></a>" }
    print "<td>$MARK$message_count</td>",
      "<td bgcolor='$checkbox_color'><input type='checkbox' name='MID' value='$MID' onClick='pointArrow()'></td>",
      "<td>$from</td>",
      "<td>",(fmtdate($date+$time_offset)),"</td>",
      "<td><a href=javascript:readMess($MID,$read,$message_count)>$subject</a></td>",
      "<td align='right'>",$paperclip,sprintf("%0.1fK",$mess_size/1024),"</td>",
      "</tr>";
    return $message_count++;
}

sub fmtdate {			# convert Epoch seconds into a particular date string
    my @weekday = qw/Sun Mon Tue Wed Thu Fri Sat/;
    my($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime($_[0]);     # the time zone difference already in
    my $hr;
    return sprintf "%s&nbsp;%d/%d,&nbsp;%d:%02d<font size='-1'>%s</font>",
      $weekday[$wday],$mon+1,$mday,($hr = $hour % 12) ? $hr : 12,$min,($hour >= 12 ? "PM" : "AM"),
  }

# sub EmptyTrash {
#     $email_ID = shift;
#     open(MAILBOX,"+<$::db_path/$email_ID/folders") || die "$lang{CouldNotOpen} $::db_path/$email_ID/folders. $!";
#     my (@folders,$folder_info);
#     while (($_ = <MAILBOX>) and ($_ ne "\n")) {push @folders,$_}
#     my @messages = <MAILBOX>;
#     my ($folder_list,$ref_this_folder_info);
#     foreach (@folders) {
# 	my @folder_info = split /,/;
# 	($ref_this_folder_info = \@folder_info) if ($folder_info[0] eq $folder);
# 	$folder_list .= "$folder_info[0],";
#     }
#     if ($folders[1] !~ /^Trash,(\d)/) {  # something wrong here, trash should be second
# 	close MAILBOX;
# 	return ($ref_this_folder_info, \@messages, $folder_list, 2, \@folders);
#     }

#     if ($1 == 0) {   # the trash is already empty
# 	close MAILBOX;
# 	return ($ref_this_folder_info,\@messages,$folder_list,1,\@folders);
#     }
#     $folders[1] = "Trash,0,0,0\n";
#     my $this_MID;
#     for ($i=0; $i < @messages; $i++) {
# 	if ($messages[$i] =~ /^.\|Trash\|/) {
# 	    $this_MID = (split /\|/,$messages[$i])[5];
# 	    splice @messages, $i, 1;
# 	    unlink ("$::db_path/$email_ID/$this_MID");
# 	    $i--;            # Decrement becasue we have one less item in the array
# 	}
#     }
#     seek MAILBOX, 0, 0;
#     print MAILBOX @folders,"\n",@messages;
#     truncate MAILBOX, (tell MAILBOX);
#     close MAILBOX;
#     unlink ("$::db_path/$email_ID/folders.undo");
#     return ($ref_this_folder_info, \@messages, $folder_list, 0, \@folders);
# }

# sub Seek_message {             # Finds the next message in the folder, either before or after
#     $ref_folder_info = shift;
#     $ref_messages = shift;
#     $MID = shift;
#     $start_index = shift;
#     $dir = shift;		# 0 for next, -1 for prev
#     if ($dir == 0) {
# 	@seek_index = ($start_index..@$ref_messages);
#     }
#     else {
# 	$start_index = $start_index || @$ref_messages;
# 	@seek_index = reverse (0..$start_index);
#     }
#     my ($found,$changed) = 0, 0;
#     foreach $this_index (@seek_index) {
# 	@message_info = (split /\|/, $ref_messages->[$this_index]);
# 	if ($found) {

# 	    if ($message_info[1] eq $ref_folder_info->[0]) { # This is the next message in the folder
# 		if ($ref_messages->[$this_index] =~ s/^0/1/) { # This one is unread
# 		    $ref_folder_info->[2]--;
# 		    $changed = 1;
# 		}
# 		return ($message_info[5],$changed); # This is the new MID
# 	    }			# Not in the folder
# 	    else {
#  		next;
# 	    }
# 	}
# 	elsif ($message_info[5] == $MID) {	# we don't check folder because it might have moved
# 	    $found = 1;
# 	}
#     }				# We got no next one in there, so go back to folder
#     return (0,0);
# }

# sub Move_search_messages { # move, different from pop
#     my $email_ID = shift;
#     my $folder_to = shift;
#     my $ref_MID_list = shift;
#     my $ref_mess_nums = shift;
#     my $ref_folder_search_list = shift;
#     my $read = shift;    # this is a flag for reading a message vs looking at folders
#     open(MAILBOX,"+<$::db_path/$email_ID/folders") || die "$lang{CouldNotOpen} $::db_path/$email_ID/folders. $!";
#     my (@folders,$folder_info);
#     while (($folder_info = <MAILBOX>) and ($folder_info ne "\n")) {push @folders,$folder_info}
#     my @messages = <MAILBOX>;
#     my ($folder_messages);
#     my ($folder_exists,%folder_info,$folder_list);
#     foreach (@folders) {
# 	my @folder_info = split /,/;
# 	$folder_list .= "$folder_info[0],";
# 	($folder_exists = 1) if ($folder_info[0] eq $folder_to);
# 	chop $folder_info[3];
# 	$folder_info{$folder_info[0]} = \@folder_info;
#     }
#     unless ($folder_exists) {                    # It's a new folder
# 	if ($folder_to =~ /[^\w-.#@!?+=() ]/) {       # I guess this is my list of legal characters
# 	    close MAILBOX;
# 	    return (-1,$folder_list,\@messages);
# 	}
# 	if ($folder_to =~ /.{14}/) {
# 	    close MAILBOX;
# 	    return (-2,$folder_list,\@messages);
# 	}
# 	# This looks like a valid folder name
# 	$folder_list .= "$folder_to,";
# 	$folder_info{$folder_to} = [$folder_to,0,0,0];
#     }
#     my ($this_message,@this_message);
#     my ($num_mov,@moved_these);
#     for ($i = 0; $i < @messages; $i++) {
# 	@this_message = (split /\|/, $messages[$i]);
# 	foreach my $MID (@$ref_MID_list) {
# 	    if ($MID == $this_message[5]) { # This message will be moved
# 		$folder_info{$this_message[1]}->[1]--;
# 		$folder_info{$folder_to}->[1]++;
# 		if ($this_message[0] == 0) {
# 		    $folder_info{$this_message[1]}->[2]--;
# 		    $folder_info{$folder_to}->[2]++;
# 		}
# 		$folder_info{$this_message[1]}->[3] -= $this_message[7];
# 		$folder_info{$folder_to}->[3] += $this_message[7];
# 		$this_message[1] = $folder_to;
# 		$messages[$i] = (join '|', @this_message);     # There should be a CR at the end of the line already
# 		$num_mov++;
# 		push @moved_these, $i;
# 		last;
# 	    }
# 	}
#     }
#     my $i;
#     if ($num_mov) {
# 	if ($read) {
# 	    my ($found,$next_index);
# 	    foreach (@$ref_mess_nums) {
# 		if ($found) {$next_index = $_; last};
# 		$found = 1 if ($moved_these[0] == $_);
# 	    }
# 	    if (defined($next_index)) {
# 		@next_message_info = split /\|/, $messages[$next_index];
# 		$next_MID = $next_message_info[5];
# 		if ($messages[$next_index] =~ s/^0/1/) {
# 		    @{$next_message_info[1]}[2]--;
# 		}
# 	    }
# 	    else { $next_MID = 0 }
# 	}
# 	foreach (split /,/, $folder_list) {
# 	    $folders[$i++] = (join ',', @{$folder_info{$_}} ) . "\n";
# 	}
# 	seek MAILBOX, 0, 0;
# 	print MAILBOX @folders,"\n",@messages;
# 	truncate MAILBOX, (tell MAILBOX);
#     }
#     close MAILBOX;
#     &Check_remove($folder_to,\@moved_these,$ref_mess_nums,$ref_folder_search_list) if ($ref_folder_search_list->[0] ne 'All');
#     return ($num_mov,$folder_list,\@messages,$next_MID);
# }

sub Seek_search {
    my $ref_mess_nums = shift;
    my $ref_folder_info_hash = shift;
    my $ref_messages = shift;
    my $previous_index = shift;
    my $direction = shift;
    my @index_list = ($direction) ? reverse @$ref_mess_nums : @$ref_mess_nums;
    my ($found, $next_index);
    foreach (@index_list) {
	if ($found) {$next_index = $_; last};
	$found = 1 if ($previous_index == $_);
    }
    my $surround_status;
    if ($next_index == pop @mess_nums) {
	$surround_status = 1 + $previous;
    }
    my ($change,@next_message_info,$next_MID);
    if (defined($next_index)) {
	@next_message_info = split /\|/, $ref_messages->[$next_index];
	$next_MID = $next_message_info[5];
	if ($ref_messages->[$next_index] =~ s/^0/1/) {
	    $ref_folder_info_hash->{$next_message_info[1]}->[2]--;
	    $change = 1;
	}
	return ($next_MID, $surround_status, $change);
    }
    return (0,0);
}

# sub Check_remove {
#     my $folder_to = shift;
#     my $ref_moved_these = shift;
#     my $ref_mess_nums = shift;
#     my $ref_folder_search_list = shift;
#     my $in_search;
#     foreach (@$ref_folder_search_list) {
# 	if ($_ eq $folder_to) {
# 	    $in_search = 1;
# 	    last;
# 	}
#     }
#     return if $in_search;
#     foreach my $moved (@$ref_moved_these) {
# 	for ($i=0; $i < @$ref_mess_nums; $i++) {
# 	    if ($moved == $ref_mess_nums->[$i]) {
# 		splice @$ref_mess_nums,$i,1;
# 		last;
# 	    }
# 	}
#     }
# }

sub qqq {    # purely for debugging
print "Content-Type: text/html\n\n";
}

sub Make_undo {      # make a couple of backups, since this file is pretty important
    use Fcntl qw(:DEFAULT :flock);
    my $email_ID = shift;
    rename ("$::db_path/$email_ID/folders.undo2", "$::db_path/$email_ID/folders.undo3");
    rename ("$::db_path/$email_ID/folders.undo", "$::db_path/$email_ID/folders.undo2") if -e "$::db_path/$email_ID/folders.undo";
#    rename ("$::db_path/$email_ID/folders", "$::db_path/$email_ID/folders.undo");
    system ('cp',"$::db_path/$email_ID/folders", "$::db_path/$email_ID/folders.undo");
    open (MAILBOX, ">$::db_path/$email_ID/folders") || die "$lang{CouldNotOpen} $::db_path/$email_ID/folders. $!";
    flock(MAILBOX,2) || die "$lang{CouldNotLock} $::db_path/$email_ID/folders. $!";
    return *MAILBOX;
}

sub Check_folder_name {
    $folder2 = shift;
    if ($folder2 =~ /[^\w-.#@!?+=() ]/) {        # I guess this is my list of legal characters
	return "<font color='$problem_color'>Your new folder name contains illegal characters.</font>";
    }
    if ($folder2 =~ /.{14}/) {
	return "<font color='$problem_color'>Please limit your folder names to 13 characters.</font>";
    }
    if ($folder2 eq 'All') {
	return "<font color='$problem_color'>Sorry, that is a reserved folder name.</font>";
    }
}

sub Put_message {           # This puts the messages in the folder in date order.
    my $this_time = shift;  # I used my own sorting algorithm since most of them will be in order
    my $this_mess = shift;
    my $ref_messages = shift;
    my $mess_num = 0;
    while ($mess_num < @$ref_messages) {
	if ($this_time > (split /\|/, $ref_messages->[$mess_num])[4]) {
	    splice @$ref_messages, $mess_num, 0, $this_mess;
	    return;
	}
	$mess_num++;
    }
    # If we got this far, then this is the oldest message, so put at end
    push @$ref_messages, $this_mess;
}

sub Get_head {
    my $message_line_number = $_[1];
    my (@head);
    while ($_ = shift @{$_[0]}) { # take off the header
	$message_line_number++;
	if ($_ eq "\n") {
	    last;
	}
	push @head, $_;
    }				# Now message is just the body
    chomp @head;
    return (\@head,$message_line_number);
}

sub is_admin_user {
  my $current_user = shift;
  my $result=0;
  foreach my $name (@::Admin_Users) {
    if ($name eq $current_user) {
      $result=1;
      last;
    }
  }  
  return $result
}

sub Check_quota {
  my ($quota_limit, $showuser) = @_;
    my $target = $::db_path;
    my $dir_size;
    my $QPercent;
    my $line;
    my $junk;

            open(DIR, "du -sk $target/$showuser|") || cgierr("Can't open $target
/$showuser");
            $line = <DIR>;
            ($dir_size, $junk) = split /\s/, $line;
            close(DIR);
           # $dir_size .= " kb";

$QPercent = int($dir_size * 10000 / $quota_limit + .5) /100;

return ($dir_size, $QPercent);
}

sub Send_undeliverable {
my ($email, $subject) = @_;
my $message_header;

$from_email = "POSTMASTER\@$web_domain";
$smtp = Net::SMTP->new($POP_Server, Hello=>$web_domain, Debug=>1);
$smtp->mail($from_email);
$smtp->to($email);
$message_header = "To: $email\n";
$message_header .="From: $from_email\n";
$message_header .="Subject: $subject -  Message Undeliverable\n";
$message_header .="X-Mailer: \"Custom Lynx presents CuLy Mail, Version 1.0\"\n";
$message_header .="\n";
$message_header .="Sorry, $to_user\@$web_domain is not a known user.\n";
$message_header .="--------------------------------------\n\n";
#$message_header .="@$ref_mess"; Would like to send body back..
$smtp->data();
$smtp->datasend($message_header);
$smtp->datasend("\n");
$smtp->dataend();
$smtp->quit;


return $result
}

sub save_setuppl {
# Things to do.
}

1;

