#!/usr/bin/perl --
use CGI::Carp qw(fatalsToBrowser);


check_libraries();

print "Content-type: text/html\n\n";
print "<html><body></table><br><br><table width=50%><tr><td>If you did not receive any errors, CuLy Mail will work on your server without any additional modules.  If you were missing any required modules, you would have received an error page listing the missing module.<br><br></center>
Thanks,<br>
CuLy Mail Developers<br></td></tr></table></body></html>\n";


sub check_libraries {
# --------------------------------------------------------
# Required Librariers
# Make sure we have Net::SMTP to connect to an smtp server.

    eval {
        require Net::SMTP;
    };
    if ($@) {
        my $message = "<font size=+2>Error loading required libraries - Net::SMTP </font>:\n\t";
        $message .= qq~CuLy Mail requires Net::SMTP to connect to an SMTP server to send mail.
\t
\t Unfortunatly, this script only displays 1 error at a time, but CuLy Mail
\tneeds the following modules to work.  Check with your hosting provider to
\tsee if they will install the required module above, and any listed below 
\tthat are not already installed.  Then, after you (or your provider) have
\tinstalled the above module, run this script again to see if you have any
\tmore missing modules.
\t
\tNet::SMTP
\tNet::POP3
\tMIME::Base64
\tDB_File
\t
\tThanks,
\tCuLy Mail Developers
~;
        library_error($message);
    }
    eval {
        require Net::POP3;
    };
    if ($@) {
        my $message = "<font size=+2>Error loading required libraries - Net::POP3</font>\n\t";
        $message .= qq~CuLy Mail requires Net::POP3 to connect to your catchall POP3 mailbox as well as to connect to user specified external POP3 accounts.
\t
\t Unfortunatly, this script only displays 1 error at a time, but CuLy Mail
\tneeds the following modules to work.  Check with your hosting provider to
\tsee if they will install the required module above, and any listed below 
\tthat are not already installed.  Then, after you (or your provider) have
\tinstalled the above module, run this script again to see if you have any
\tmore missing modules.
\t
\tNet::SMTP
\tNet::POP3
\tMIME::Base64
\tDB_File
\t
\tThanks,
\tCuLy Mail Developers
~;
        library_error($message);
    }

    eval {
        require MIME::Base64;
    };
    if ($@) {
        my $message = "<font size=+2>Error loading required libraries - MIME::Base64</font>\n\t";
        $message .= qq~CuLy Mail needs MIME::Base64 to encode your file attachments into your e-mail.
\t
\t Unfortunatly, this script only displays 1 error at a time, but CuLy Mail
\tneeds the following modules to work.  Check with your hosting provider to
\tsee if they will install the required module above, and any listed below
\tthat are not already installed.  Then, after you (or your provider) have
\tinstalled the above module, run this script again to see if you have any
\tmore missing modules.
\t
\tNet::SMTP
\tNet::POP3
\tMIME::Base64
\tDB_File
\t
\tThanks,
\tCuLy Mail Developers
~;
        library_error($message);
    }

    eval {
        require DB_File;
        require 5.004;          # We need at least Perl 5.004
    };
    if ($@) { &cgierr("CuLy Mail _MAY_ require at least perl version 5.004 or better.  You are using: $[. ($@)"); }

};

sub library_error{
# --------------------------------------------------------
# HTML error page.  Displayed when there error occurred while
# loading required libraries.

    my ($message) = @_;
    if (defined $GT::CGI::PRINTED_HEAD) {
        print "Content-type: text/html\n\n" unless ($GT::CGI::PRINTED_HEAD);
    }
    else {
        print "Content-type: text/html\n\n";
    }
    print qq~<HTML>
<HEAD>
<TITLE>
CuLy Mail - Error loading required libraries.
</TITLE>
</HEAD>

<BODY BGCOLOR="#CCCCCC">

<table border=1 bgcolor="#FFFFFF" cellpadding=5 cellspacing=3 width="100%" align=center valign=top>
    <tr>
        <td bgcolor="navy">
          <FONT FACE="MS Sans Serif, arial,helvetica" size=1 COLOR="#FFFFFF">
          <b>CuLy Mail: Error loading required libraries.</b>
          </font>
        </td>
    </tr>
    <tr>
        <td>
            <UL>
            <pre>
            <font FACE="MS Sans Serif, arial,helvetica">
$message
            </font>
            </pre>
            </UL>
        </td>
    </tr>
</table>

</BODY>
</HTML>

~;

exit;
};
